#! /boot/home/config/bin/ruby
require "bfs.so"

nl   = "\n"                #=> new line
indt = "    "              #=> indent depth
hr   = ("-"*75).center(80) #=> horizontal line
hr   = nl+hr.gsub(/ +$/, nil)+nl



print <<-HEAD
#
#  methods.rb
#
#  1. install `bfs.so'
#    $ ruby extconf.rb
#    $ make
#    $ make site-install
#
#  2. optional `bfs.rb' and documentation
#    $ cp bfs.rb /boot/home/config/lib/ruby/site_ruby/1.6
#    $ cp -r documentation/ruby-bfs /boot/home/config/documentation
#
#  3. generate methods and constants list
#    $ ruby methods.rb > methods.txt
#    $ ruby -r bfs -e'File.open("methods.txt") {|f| Bfs::Attr.addattr(f, "BEOS:TYPE", "text/plain", Bfs::MIME_STRING_TYPE) }'
#

HEAD



print <<-MODULE

-- #{Bfs.name} (#{Bfs.type})
  -- constants
#{indt + Bfs.constants.grep(/.*_.*/).sort.join(nl+indt)}
#{hr}
MODULE


[ Bfs::Volume, Bfs::Query,
  Bfs::Index,  Bfs::Attr  ].each {| klass |

  print <<-KLASS
-- #{klass.name} < #{klass.superclass}
  -- included modules
#{indt + klass.included_modules.join(nl+indt)}

  -- singleton methods
#{indt + klass.singleton_methods.sort.join(nl+indt)}

  -- methods
#{indt + klass.public_instance_methods.sort.join(nl+indt)}
#{hr}
  KLASS
}


print <<-SIGNATURE

--
Satoshi Nojo
mailto:s_nojo@geocities.co.jp
SIGNATURE
