#! /boot/home/config/bin/ruby

#
# bfs_test.rb
#


#  assert(condition, message="")
#  assert_equal(expected, actual, message="")
#  assert_equal_float(expected, actual, e, message="")
#  assert_same(expected, actual, message="")
#  assert_nil(obj, message="")
#  assert_not_nil(obj, message="")
#  assert_respond_to(method, obj, message="")
#  assert_kind_of(c, obj, message="")
#  assert_instance_of(c, obj, message="")
#  assert_match(str, re, message="")
#  assert_not_match(str, re, message="")
#  assert_exception(exception, message="")
#  assert_no_exception(*arg)
#  assert_fail(message, level=2)


require "runit/testcase"
require "bfs.so"

class VolumeTest < RUNIT::TestCase

#  def setup
#    GC.disable
#    GC.enable
#    GC.start
#  end

#  def teardown
#    GC.start
#  end

  def test_000_new
    v = Bfs::Volume.new("/")
    assert_instance_of(Bfs::Volume, v)
  end

  def test_001_new
    f = File.open("/")
    v = Bfs::Volume.new(f)
    assert_instance_of(Bfs::Volume, v)
  end

  def test_002_new
    devno = File.open("/").stat.dev
    v = Bfs::Volume.new(devno)
    assert_instance_of(Bfs::Volume, v)
  end

  def test_003_new
    d = Dir.open("/")
    v = Bfs::Volume.new(d)
    assert_instance_of(Bfs::Volume, v)
  end

  def test_004_new
    v = Bfs::Volume.new("/")
    v = Bfs::Volume.new(v)
    assert_instance_of(Bfs::Volume, v)
  end

  def test_005_new
    assert_exception(ArgumentError) {
      Bfs::Volume.new
    }
  end

  def test_006_new
    assert_exception(ArgumentError) {
      Bfs::Volume.new(nil, nil)
    }
  end

  def test_007_new
    assert_exception(TypeError) {
      Bfs::Volume.new(nil)
    }
  end

  def test_008_new
    assert_exception(Errno::ENOENT) {
      Bfs::Volume.new("")
    }
  end

  def test_009_new
    assert_exception(Errno::ENAMETOOLONG) {
      Bfs::Volume.new(" "*256)
    }
  end

  def test_00a_new
    f = File.open("/")
    f.close
    assert_exception(IOError) {
      Bfs::Volume.new(f)
    }
  end

  def test_00b_new
    assert_exception(Errno::EINVAL) {
      Bfs::Volume.new(-1)
    }
  end

  def test_00c_new
    assert_exception(RangeError) {
      Bfs::Volume.new(2**31)
    }
  end

  def test_00d_new
    d = Dir.open("/")
    d.close
    assert_exception(IOError) {
      Bfs::Volume.new(d)
    }
  end

  def test_010_cmp
    v1 = Bfs::Volume.new("/")
    v2 = Bfs::Volume.new("/")
    assert(v1 == v2)
  end

  def test_011_cmp
    v1 = Bfs::Volume.new("/")
    v2 = Bfs::Volume.new("/dev")
    assert(v1 != v2)
  end

end

if $0 == __FILE__
  require "runit/cui/testrunner"
  RUNIT::CUI::TestRunner.run(VolumeTest.suite)
end
